class Fn:
    def __init__(self, fn):
        self.fn = fn

    def __call__(self, param):
        return self.fn(param)

    def __add__(self, other):
        return Fn(lambda x: self(other(x)))

    def __mul__(self, other):
        return Fn(lambda x: self(x)(other(x)))


comp = Fn(lambda a: Fn(lambda b: a + b))
ap = Fn(lambda a: Fn(lambda b: a * b))
const = Fn(lambda x: Fn(lambda _: x))
Y = Fn(lambda f: Fn(lambda x: x(x))(Fn(lambda x: f(Fn(lambda y: x(x)(y))))))

id = const * const
apply = const(ap) * (const(const) * id) * const(id)
flip = (const(const(ap) * const)) * ap * const(const)
applyto = flip(apply)
join = ap * ap(const)

true = const
false = const(id)

pair = flip + applyto
car = applyto(true)
cdr = applyto(false)

cons = pair
head = car
tail = cdr
nil = false
isnil = applyto(true) + applyto(const(const(const(false))))

map = Y(lambda r: lambda f: lambda l: isnil(l)(const(nil))((cons + f + head)(l) + r(f) + tail)(l))
fold = Y(lambda r: lambda f: lambda b: lambda l: isnil(l)(const(b))(lambda l: r(f)(f(b)(car(l)))(cdr(l)))(l))

sum = fold(comp)(0)
product = fold(ap)(1)

def transpose(x): return [[l[i] for l in x] for i in range(len(x[0]))]
def convert(l): return (cons(convert(l[0]))(convert(l[1:])) if l else nil) if type(l) == list else l
def entry(a, b): return sum(map(product)(convert(transpose([a, b]))))
